(module
 (type $FUNCSIG$iii (func (param i32 i32) (result i32)))
 (type $FUNCSIG$v (func))
 (type $FUNCSIG$vi (func (param i32)))
 (type $FUNCSIG$iiii (func (param i32 i32 i32) (result i32)))
 (import "env" "abort" (func $abort))
 (import "env" "exit" (func $exit (param i32)))
 (import "env" "fprintf" (func $fprintf (param i32 i32 i32) (result i32)))
 (import "env" "stderr" (global $stderr i32))
 (table 0 anyfunc)
 (memory $0 17)
 (data (i32.const 4) "0\00\10\00")
 (data (i32.const 12) "\00\00\00\00")
 (data (i32.const 16) "Test failed: %s\n\00")
 (export "memory" (memory $0))
 (export "fp_add" (func $fp_add))
 (export "fp_sub" (func $fp_sub))
 (export "fp_mul" (func $fp_mul))
 (export "fp_div" (func $fp_div))
 (export "fp_neg" (func $fp_neg))
 (export "dp_add" (func $dp_add))
 (export "dp_sub" (func $dp_sub))
 (export "dp_mul" (func $dp_mul))
 (export "dp_div" (func $dp_div))
 (export "dp_neg" (func $dp_neg))
 (export "fp_to_dp" (func $fp_to_dp))
 (export "dp_to_fp" (func $dp_to_fp))
 (export "eqsf2" (func $eqsf2))
 (export "nesf2" (func $nesf2))
 (export "gtsf2" (func $gtsf2))
 (export "gesf2" (func $gesf2))
 (export "ltsf2" (func $ltsf2))
 (export "lesf2" (func $lesf2))
 (export "eqdf2" (func $eqdf2))
 (export "nedf2" (func $nedf2))
 (export "gtdf2" (func $gtdf2))
 (export "gedf2" (func $gedf2))
 (export "ltdf2" (func $ltdf2))
 (export "ledf2" (func $ledf2))
 (export "floatsisf" (func $floatsisf))
 (export "floatsidf" (func $floatsidf))
 (export "fixsfsi" (func $fixsfsi))
 (export "fixdfsi" (func $fixdfsi))
 (export "fixunssfsi" (func $fixunssfsi))
 (export "fixunsdfsi" (func $fixunsdfsi))
 (export "fail" (func $fail))
 (export "main" (func $main))
 (func $fp_add (; 3 ;) (param $0 f32) (param $1 f32) (result f32)
  (f32.add
   (get_local $0)
   (get_local $1)
  )
 )
 (func $fp_sub (; 4 ;) (param $0 f32) (param $1 f32) (result f32)
  (f32.sub
   (get_local $0)
   (get_local $1)
  )
 )
 (func $fp_mul (; 5 ;) (param $0 f32) (param $1 f32) (result f32)
  (f32.mul
   (get_local $0)
   (get_local $1)
  )
 )
 (func $fp_div (; 6 ;) (param $0 f32) (param $1 f32) (result f32)
  (f32.div
   (get_local $0)
   (get_local $1)
  )
 )
 (func $fp_neg (; 7 ;) (param $0 f32) (result f32)
  (f32.neg
   (get_local $0)
  )
 )
 (func $dp_add (; 8 ;) (param $0 f64) (param $1 f64) (result f64)
  (f64.add
   (get_local $0)
   (get_local $1)
  )
 )
 (func $dp_sub (; 9 ;) (param $0 f64) (param $1 f64) (result f64)
  (f64.sub
   (get_local $0)
   (get_local $1)
  )
 )
 (func $dp_mul (; 10 ;) (param $0 f64) (param $1 f64) (result f64)
  (f64.mul
   (get_local $0)
   (get_local $1)
  )
 )
 (func $dp_div (; 11 ;) (param $0 f64) (param $1 f64) (result f64)
  (f64.div
   (get_local $0)
   (get_local $1)
  )
 )
 (func $dp_neg (; 12 ;) (param $0 f64) (result f64)
  (f64.neg
   (get_local $0)
  )
 )
 (func $fp_to_dp (; 13 ;) (param $0 f32) (result f64)
  (f64.promote/f32
   (get_local $0)
  )
 )
 (func $dp_to_fp (; 14 ;) (param $0 f64) (result f32)
  (f32.demote/f64
   (get_local $0)
  )
 )
 (func $eqsf2 (; 15 ;) (param $0 f32) (param $1 f32) (result i32)
  (f32.eq
   (get_local $0)
   (get_local $1)
  )
 )
 (func $nesf2 (; 16 ;) (param $0 f32) (param $1 f32) (result i32)
  (f32.ne
   (get_local $0)
   (get_local $1)
  )
 )
 (func $gtsf2 (; 17 ;) (param $0 f32) (param $1 f32) (result i32)
  (f32.gt
   (get_local $0)
   (get_local $1)
  )
 )
 (func $gesf2 (; 18 ;) (param $0 f32) (param $1 f32) (result i32)
  (f32.ge
   (get_local $0)
   (get_local $1)
  )
 )
 (func $ltsf2 (; 19 ;) (param $0 f32) (param $1 f32) (result i32)
  (f32.lt
   (get_local $0)
   (get_local $1)
  )
 )
 (func $lesf2 (; 20 ;) (param $0 f32) (param $1 f32) (result i32)
  (f32.le
   (get_local $0)
   (get_local $1)
  )
 )
 (func $eqdf2 (; 21 ;) (param $0 f64) (param $1 f64) (result i32)
  (f64.eq
   (get_local $0)
   (get_local $1)
  )
 )
 (func $nedf2 (; 22 ;) (param $0 f64) (param $1 f64) (result i32)
  (f64.ne
   (get_local $0)
   (get_local $1)
  )
 )
 (func $gtdf2 (; 23 ;) (param $0 f64) (param $1 f64) (result i32)
  (f64.gt
   (get_local $0)
   (get_local $1)
  )
 )
 (func $gedf2 (; 24 ;) (param $0 f64) (param $1 f64) (result i32)
  (f64.ge
   (get_local $0)
   (get_local $1)
  )
 )
 (func $ltdf2 (; 25 ;) (param $0 f64) (param $1 f64) (result i32)
  (f64.lt
   (get_local $0)
   (get_local $1)
  )
 )
 (func $ledf2 (; 26 ;) (param $0 f64) (param $1 f64) (result i32)
  (f64.le
   (get_local $0)
   (get_local $1)
  )
 )
 (func $floatsisf (; 27 ;) (param $0 i32) (result f32)
  (f32.convert_s/i32
   (get_local $0)
  )
 )
 (func $floatsidf (; 28 ;) (param $0 i32) (result f64)
  (f64.convert_s/i32
   (get_local $0)
  )
 )
 (func $fixsfsi (; 29 ;) (param $0 f32) (result i32)
  (block $label$0
   (br_if $label$0
    (f32.lt
     (f32.abs
      (get_local $0)
     )
     (f32.const 2147483648)
    )
   )
   (return
    (i32.const -2147483648)
   )
  )
  (i32.trunc_s/f32
   (get_local $0)
  )
 )
 (func $fixdfsi (; 30 ;) (param $0 f64) (result i32)
  (block $label$0
   (br_if $label$0
    (f64.lt
     (f64.abs
      (get_local $0)
     )
     (f64.const 2147483648)
    )
   )
   (return
    (i32.const -2147483648)
   )
  )
  (i32.trunc_s/f64
   (get_local $0)
  )
 )
 (func $fixunssfsi (; 31 ;) (param $0 f32) (result i32)
  (block $label$0
   (br_if $label$0
    (i32.and
     (f32.lt
      (get_local $0)
      (f32.const 4294967296)
     )
     (f32.ge
      (get_local $0)
      (f32.const 0)
     )
    )
   )
   (return
    (i32.const 0)
   )
  )
  (i32.trunc_u/f32
   (get_local $0)
  )
 )
 (func $fixunsdfsi (; 32 ;) (param $0 f64) (result i32)
  (block $label$0
   (br_if $label$0
    (i32.and
     (f64.lt
      (get_local $0)
      (f64.const 4294967296)
     )
     (f64.ge
      (get_local $0)
      (f64.const 0)
     )
    )
   )
   (return
    (i32.const 0)
   )
  )
  (i32.trunc_u/f64
   (get_local $0)
  )
 )
 (func $fail (; 33 ;) (param $0 i32) (result i32)
  (local $1 i32)
  (set_local $1
   (i32.sub
    (i32.load offset=4
     (i32.const 0)
    )
    (i32.const 16)
   )
  )
  (i32.store offset=4
   (i32.const 0)
   (get_local $1)
  )
  (i32.store offset=12
   (i32.const 0)
   (i32.add
    (i32.load offset=12
     (i32.const 0)
    )
    (i32.const 1)
   )
  )
  (i32.store
   (get_local $1)
   (get_local $0)
  )
  (drop
   (call $fprintf
    (i32.load
     (get_global $stderr)
    )
    (i32.const 16)
    (get_local $1)
   )
  )
  (i32.store offset=4
   (i32.const 0)
   (i32.add
    (get_local $1)
    (i32.const 16)
   )
  )
  (get_local $1)
 )
 (func $main (; 34 ;) (result i32)
  (block $label$0
   (br_if $label$0
    (i32.load offset=12
     (i32.const 0)
    )
   )
   (call $exit
    (i32.const 0)
   )
   (unreachable)
  )
  (call $abort)
  (unreachable)
 )
)
